diff --git a/gnu/local.mk b/gnu/local.mk
index ce58d5bfb4..b763991d63 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -2216,6 +2216,7 @@ dist_patch_DATA =						\
   %D%/packages/patches/turbovnc-find-system-packages.patch	\
   %D%/packages/patches/tuxpaint-stamps-path.patch		\
   %D%/packages/patches/twinkle-bcg729.patch			\
+  %D%/packages/patches/u-boot-50M-kernel.patch			\
   %D%/packages/patches/u-boot-allow-disabling-openssl.patch	\
   %D%/packages/patches/u-boot-nintendo-nes-serial.patch		\
   %D%/packages/patches/u-boot-rockchip-inno-usb.patch		\
diff --git a/gnu/packages/bootloaders.scm b/gnu/packages/bootloaders.scm
index 50e7bb8bbc..b38b407d38 100644
--- a/gnu/packages/bootloaders.scm
+++ b/gnu/packages/bootloaders.scm
@@ -826,37 +826,32 @@ (define-public dtc
 tree binary files.  These are board description files used by Linux and BSD.")
     (license license:gpl2+)))
 
-(define %u-boot-rockchip-inno-usb-patch
-  ;; Fix regression in 2020.10 causing freezes on boot with USB boot enabled.
-  ;; See https://gitlab.manjaro.org/manjaro-arm/packages/core/uboot-rockpro64/-/issues/4
-  ;; and https://patchwork.ozlabs.org/project/uboot/patch/20210406151059.1187379-1-icenowy@aosc.io
-  (search-patch "u-boot-rockchip-inno-usb.patch"))
-
-(define %u-boot-allow-disabling-openssl-patch
-  ;; Fixes build of u-boot 2021.10 without openssl
-  ;; https://lists.denx.de/pipermail/u-boot/2021-October/462728.html
-  (search-patch "u-boot-allow-disabling-openssl.patch"))
-
-(define %u-boot-nanopi-r4s-ddr3-patch
-  ;; Use DDR3 instead of LPDDR4 for the Nano Pi R4S U-boot.
-  (search-patch "u-boot-nanopi-r4s-ddr3.patch"))
-
 (define u-boot
   (package
     (name "u-boot")
     (version "2024.07")
-    (source (origin
-              (patches
-               (list %u-boot-rockchip-inno-usb-patch
-                     %u-boot-allow-disabling-openssl-patch
-                     %u-boot-nanopi-r4s-ddr3-patch))
-              (method url-fetch)
-              (uri (string-append
-                    "https://ftp.denx.de/pub/u-boot/"
-                    "u-boot-" version ".tar.bz2"))
-              (sha256
-               (base32
-                "13rwv28g6z8ihrs8k0066gblw37rvw6nsxkks6rxdwqfp6ddm4gm"))))
+    (source
+      (origin
+        (patches
+          (search-patches
+            ;; Fix regression in 2020.10 causing freezes on boot with
+            ;; USB boot enabled.  See:
+            ;; https://gitlab.manjaro.org/manjaro-arm/packages/core/uboot-rockpro64/-/issues/4
+            ;; https://patchwork.ozlabs.org/project/uboot/patch/20210406151059.1187379-1-icenowy@aosc.io
+            "u-boot-rockchip-inno-usb.patch"
+            ;; Fixes build of u-boot 2021.10 without openssl.  See:
+            ;; https://lists.denx.de/pipermail/u-boot/2021-October/462728.html
+            "u-boot-allow-disabling-openssl.patch"
+            ;; Use DDR3 instead of LPDDR4 for the Nano Pi R4S.
+            "u-boot-nanopi-r4s-ddr3.patch"
+            ;; Reserve more than 36 MB for linux-libre 6.9+ kernels.
+            "u-boot-50M-kernel.patch"))
+        (method url-fetch)
+        (uri (string-append "https://ftp.denx.de/pub/u-boot/"
+                            "u-boot-" version ".tar.bz2"))
+        (sha256
+          (base32
+            "13rwv28g6z8ihrs8k0066gblw37rvw6nsxkks6rxdwqfp6ddm4gm"))))
     (build-system gnu-build-system)
     (native-inputs
      (list bison
diff --git a/gnu/packages/patches/u-boot-50M-kernel.patch b/gnu/packages/patches/u-boot-50M-kernel.patch
new file mode 100644
index 0000000000..4566894087
--- /dev/null
+++ b/gnu/packages/patches/u-boot-50M-kernel.patch
@@ -0,0 +1,51 @@
+This patch configures the U-Boot for Raspberry Pis to reserve 50 MB for
+linux kernels, because the 6.9 and newer linux-libre-arm64-generic
+kernels can be larger than 36 MB.  It was created by Herman Rimm
+<herman@rimm.ee> in August 2024 and is not submitted upstream yet.
+diff --git a/board/raspberrypi/rpi/rpi.env b/board/raspberrypi/rpi/rpi.env
+index 30228285ed..54a8e9e5ae 100644
+--- a/board/raspberrypi/rpi/rpi.env
++++ b/board/raspberrypi/rpi/rpi.env
+@@ -43,22 +43,22 @@ dfu_alt_info+=zImage fat 0 1
+  *   text_offset bytes (specified in the header of the Image) into a 2MB
+  *   boundary. The 'booti' command relocates the image if necessary. Linux uses
+  *   a default text_offset of 0x80000.  In summary, loading at 0x80000
+- *   satisfies all these constraints and reserving memory up to 0x02400000
+- *   permits fairly large (roughly 36M) kernels.
++ *   satisfies all these constraints and reserving memory up to 0x03400000
++ *   permits fairly large (roughly 50M) kernels.
+  *
+  * scriptaddr and pxefile_addr_r can be pretty much anywhere that doesn't
+  * conflict with something else. Reserving 1M for each of them at
+- * 0x02400000-0x02500000 and 0x02500000-0x02600000 should be plenty.
++ * 0x03200000-0x03300000 and 0x03300000-0x03400000 should be plenty.
+  *
+  * On ARM, both the DTB and any possible initrd must be loaded such that they
+  * fit inside the lowmem mapping in Linux. In practice, this usually means not
+  * more than ~700M away from the start of the kernel image but this number can
+  * be larger OR smaller depending on e.g. the 'vmalloc=xxxM' command line
+  * parameter given to the kernel. So reserving memory from low to high
+- * satisfies this constraint again. Reserving 1M at 0x02600000-0x02700000 for
+- * the DTB leaves rest of the free RAM to the initrd starting at 0x02700000.
++ * satisfies this constraint again. Reserving 1M at 0x03400000-0x03500000 for
++ * the DTB leaves rest of the free RAM to the initrd starting at 0x03500000.
+  * Even with the smallest possible CPU-GPU memory split of the CPU getting
+- * only 64M, the remaining 25M starting at 0x02700000 should allow quite
++ * only 64M, the remaining 11M starting at 0x03500000 should allow quite
+  * large initrds before they start colliding with U-Boot.
+  */
+ #ifdef CONFIG_ARM64
+@@ -69,9 +69,9 @@ fdt_high=ffffffff
+ initrd_high=ffffffff
+ #endif
+ kernel_addr_r=0x00080000
+-scriptaddr=0x02400000
+-pxefile_addr_r=0x02500000
+-fdt_addr_r=0x02600000
+-ramdisk_addr_r=0x02700000
++scriptaddr=0x03200000
++pxefile_addr_r=0x03300000
++fdt_addr_r=0x03400000
++ramdisk_addr_r=0x03500000
+ 
+ boot_targets=mmc usb pxe dhcp